//{X

unit boss1;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DDSD, dddd, ddddut, ddid, defs, shkernel, moveUtil, enemy, flare, zangai, s_MathPack, Primitives;


//{X̕
type TBoss1Weapon = class(TMover)
  private
    IamL:Boolean;     //l͍̖CłH
    mySpr:Integer;    //\XvCgԍ
    ChargeT:DWord;    //`[WJn
    FCharging:Boolean; //݃`[W
    FCooling:Boolean;   //p
    PrevShootT:Integer; //gCŌɌ
    NShoot:Integer;     //`[WEgC
  public
    constructor CreateL(owner:TMoverList; p:TPoint);
    constructor CreateR(owner:TMoverList; p:TPoint);
    destructor Destroy; override;
    procedure OnDie; override;
    procedure OnDamaged(dmg:Integer); override;
    procedure OnCrush(target:TMover); override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure Charge; //`[WČ
    property Charging:Boolean read FCharging;
end;


type TBoss1Cover = class(TMover)
  private
    mySpr:Integer;    //\XvCgԍ
  public
    constructor Create(owner:TMoverList; p:TPoint);
    destructor Destroy; override;
    procedure OnDie; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDamaged(dmg:Integer); override;
    procedure OnCrush(Target:TMover); override;
end;



//{X
type TBoss1 = class(TMover)
  private
    pos:TVector2D;      //ʒu
    curV:TVector2D;     //݂̑x
    mySpr:Integer;    //\XvCgԍ
    LWeapon,RWeapon:TBoss1Weapon; //C
    Cover:TBoss1Cover;            //Jo[
    LWAlive,RWAlive,CovAlive:Boolean;      //E̖CEJo[͐Ă邩
    ShotCount:Integer;
    PrevShot:DWord;
    Rewind:Boolean;   //^ptO
  public
    Velocity:TPoint;  //x
    constructor Create(owner:TMoverList; p:TPoint);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
    procedure OnDamaged(dmg:Integer); override;
    procedure OnCrush(Target:TMover); override;
    procedure CatchMessage(msg:Word; param:Pointer); override;
end;

//gC
type THadou = class(TMover)
  private
    pos:TVector2D;
    v0:TVector2D;  //ʒu,
  public
    iAlgo:Integer;    //ASYԍ
    Velocity:TPoint;  //x
    constructor Create(owner:TMoverList; p:TPoint; v:TVector2D); //ƈʒu
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
    procedure OnCrush(Target:TMover); override;
    procedure OnDamaged(dmg:Integer); override;
end;



implementation

////////////////////////////
// {X1A{
////////////////////////////
constructor TBoss1.Create(owner:TMoverList; p:TPoint);
begin
  inherited Create(owner);

  HP:=700;
  pos.x:=p.x;
  pos.y:=p.y;

  LWAlive:=True;
  RWAlive:=True;
  CovAlive:=True;

  ShotCount:=0;
  PrevShot:=0;

  //蔻̏
  FAttr:=maEnemy;
  nTouchRect:=5;
  FTouchRect[0]:=Rect(-88,-108,+88,+50);
  FTouchRect[1]:=Rect(-106,-124,-67,-9);
  FTouchRect[2]:=Rect(-92,-8,-65,+101);
  FTouchRect[3]:=Rect(+67,-124,+106,-9);
  FTouchRect[4]:=Rect(+65,-8,+92,+101);

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=S_Boss1;
    MinAnim:=0;
    MaxAnim:=0;
    iAnim:=0;
    Visible:=True;
    Z:=Z_NORMAL;
  end;

  //CEJo[t
  LWeapon:=TBoss1Weapon.CreateL(owner,Point(0,0));
  LWeapon.Parent:=Self;
  FOwner.Add(LWeapon);

  RWeapon:=TBoss1Weapon.CreateR(owner,Point(0,0));
  RWeapon.Parent:=Self;
  FOwner.Add(RWeapon);

  Cover:=TBoss1Cover.Create(owner,Point(0,0));
  Cover.Parent:=Self;
  FOwner.Add(Cover);

  MoveTo(Round(pos.x),Round(pos.y));

end;

destructor TBoss1.Destroy;
begin
  FOwner.FreeSprite(mySpr);
  inherited;
end;

procedure TBoss1.Move(t:Integer);
var
  DontMove:Boolean; //`[WA
  p:TVector2D;
  spd:Integer;
begin
  inherited;

  DontMove:=False;

  //AɊ|ĂAΒo
  if CanShootConst(7,12) And (HP < 100) then begin
    FOwner.Add(TSpark1.Create(FOwner, X-65,Y-20, 0,-6));
    if HP<50 then
      FOwner.Add(TSpark1.Create(FOwner, X+65,Y+20, 0,-6));
  end;

  //Ƃ肠Aʒ܂œB
  if pos.Y < 128 then begin
    CurV.Y:=4.0;
    CurV.X:=0;
  end else begin
    CurV.Y:=0.0;
    //gCĂȂAgC
    if LWAlive then
      if LWeapon.Charging then
        DontMove:=True
      else
        LWeapon.Charge;

    if RWAlive then
      if RWeapon.Charging then
        DontMove:=True
      else
        RWeapon.Charge;
  end;
  
  //Ƃ肠E
  if (not DontMove) Or (Abs(CurV.X) > 3.0) then begin
    if Rewind then
      CurV.X:=CurV.X + 0.1 *t
    else
      CurV.X:=CurV.X - 0.1 *t;

    if CurV.X < -2 then
      CurV.X:=CurV.X + 0.1 *t
    else if CurV.X > 2 then
      CurV.X:=CurV.x - 0.1 *t;
  end else begin
    CurV.X:=0;
  end;

  pos.X:=pos.X + curV.X * t;
  pos.Y:=pos.Y + curV.Y * t;

  if pos.X < 200.0 then
    Rewind:=True;
  if pos.X > 440.0 then
    Rewind:=False;

  //Jo[OĂA~TCB
  if not CovAlive then begin
    if PrevShot+4 < AgeT then begin
      if ShotCount < 4 then begin
        case GAMELEVEL of
          0:begin
            Case ShotCount of
              0:FOwner.Add(TMissile1.Create(FOwner,Point(X-33,Y+67),Vector2D( 0.0,1.0)));
              1:FOwner.Add(TMissile1.Create(FOwner,Point(X-6, Y+67),Vector2D( 0.0,1.0)));
              2:FOwner.Add(TMissile1.Create(FOwner,Point(X+6, Y+67),Vector2D( 0.0,1.0)));
              3:FOwner.Add(TMissile1.Create(FOwner,Point(X+33,Y+67),Vector2D( 0.0,1.0)));
            end;
          end;
          1:begin
            case ShotCount of
              0,2:begin
                FOwner.Add(TMissile1.Create(FOwner,Point(X-33,Y+67),Vector2D( 0.0,1.0)));
                FOwner.Add(TMissile1.Create(FOwner,Point(X+6, Y+67),Vector2D( 0.0,1.0)));
              end;
              1,3:begin
                FOwner.Add(TMissile1.Create(FOwner,Point(X-6, Y+67),Vector2D( 0.0,1.0)));
                FOwner.Add(TMissile1.Create(FOwner,Point(X+33,Y+67),Vector2D( 0.0,1.0)));
              end;
            end;
          end;
          2:begin
            if ShotCount <> 3 then begin
              FOwner.Add(TMissile1.Create(FOwner,Point(X-33,Y+67),Vector2D( 0.0,1.0)));
              FOwner.Add(TMissile1.Create(FOwner,Point(X-6, Y+67),Vector2D( 0.0,1.0)));
              FOwner.Add(TMissile1.Create(FOwner,Point(X+6, Y+67),Vector2D( 0.0,1.0)));
              FOwner.Add(TMissile1.Create(FOwner,Point(X+33,Y+67),Vector2D( 0.0,1.0)));
            end;
          end;
        end;
        //FOwner.Add(TEnemyShot1.Create(FOwner,Point(X-33,Y+67),Vector2D(0.0,8.0)));
        //FOwner.Add(TEnemyShot1.Create(FOwner,Point(X-6, Y+67),Vector2D(0.0,8.0)));
        //FOwner.Add(TEnemyShot1.Create(FOwner,Point(X+6, Y+67),Vector2D(0.0,8.0)));
        //FOwner.Add(TEnemyShot1.Create(FOwner,Point(X+33,Y+67),Vector2D(0.0,8.0)));
      end;
      PrevShot:=AgeT;
      Inc(ShotCount);
      if ShotCount > 11 then
        ShotCount:=0;
    end;
  end;

  //gCĂA@Ɍ3 ro 5Vbg
  if CanShootConst(0, GAMELEVEL*2) then begin
    p.X:=FOwner.HeroPos.X - Pos.X;
    p.Y:=FOwner.HeroPos.Y - Pos.Y;
    spd:=2;

    if not LWAlive then begin
      if GAMELEVEL = 1 then begin
        FOwner.Add(TEnemyShot2.Create(FOwner,Point(X-88,Y+122),MvRot(MvNormalize(p,spd),128,spd)));
        FOwner.Add(TEnemyShot2.Create(FOwner,Point(X-88,Y+122),MvNormalize(p,spd)));
        FOwner.Add(TEnemyShot2.Create(FOwner,Point(X-88,Y+122),MvRot(MvNormalize(p,spd),-128,spd)));
      end else if GAMELEVEL = 2 then begin
        FOwner.Add(TEnemyShot2.Create(FOwner,Point(X-88,Y+122),MvRot(MvNormalize(p,spd),192,spd)));
        FOwner.Add(TEnemyShot2.Create(FOwner,Point(X-88,Y+122),MvRot(MvNormalize(p,spd),96,spd)));
        FOwner.Add(TEnemyShot2.Create(FOwner,Point(X-88,Y+122),MvNormalize(p,spd)));
        FOwner.Add(TEnemyShot2.Create(FOwner,Point(X-88,Y+122),MvRot(MvNormalize(p,spd),-96,spd)));
        FOwner.Add(TEnemyShot2.Create(FOwner,Point(X-88,Y+122),MvRot(MvNormalize(p,spd),-192,spd)));
      end;
    end;
    if not RWAlive then begin
      if GAMELEVEL = 1 then begin
        FOwner.Add(TEnemyShot2.Create(FOwner,Point(X+88,Y+122),MvRot(MvNormalize(p,spd),128,spd)));
        FOwner.Add(TEnemyShot2.Create(FOwner,Point(X+88,Y+122),MvNormalize(p,spd)));
        FOwner.Add(TEnemyShot2.Create(FOwner,Point(X+88,Y+122),MvRot(MvNormalize(p,spd),-128,spd)));
      end else if GAMELEVEL = 2then begin
        FOwner.Add(TEnemyShot2.Create(FOwner,Point(X+88,Y+122),MvRot(MvNormalize(p,spd),192,spd)));
        FOwner.Add(TEnemyShot2.Create(FOwner,Point(X+88,Y+122),MvRot(MvNormalize(p,spd),96,spd)));
        FOwner.Add(TEnemyShot2.Create(FOwner,Point(X+88,Y+122),MvNormalize(p,spd)));
        FOwner.Add(TEnemyShot2.Create(FOwner,Point(X+88,Y+122),MvRot(MvNormalize(p,spd),-96,spd)));
        FOwner.Add(TEnemyShot2.Create(FOwner,Point(X+88,Y+122),MvRot(MvNormalize(p,spd),-192,spd)));
      end;
    end;
  end;


  MoveTo(Round(pos.x),Round(pos.y));
end;

procedure TBoss1.MoveTo(xx,yy:Integer);
begin
  pos.x:=xx;
  pos.y:=yy;
  X:=xx;
  Y:=yy;

  FOwner.Spr[mySpr].X:=xx-128;
  FOwner.Spr[mySpr].Y:=yy-128;

  if LWAlive then
    LWeapon.MoveTo(xx-144,yy);
  if RWAlive then
    RWeapon.MoveTo(xx+144,yy);
  if CovALive then
    Cover.MoveTo(xx,yy+94);
end;

procedure TBoss1.OnDie;
begin
  inherited;
  FOwner.Spr[mySpr].Hide;
end;

procedure TBoss1.OnDamaged(dmg:Integer);
var
  info:TDestroyInfo;
begin
  inherited;

  //HP炷
  Dec(HP,dmg);

  //HP0ȉɂȂA
  if HP <= 0 then begin
    FOwner.Score:=FOwner.Score + SC_BOSS1;
    //FOwner.Add(TFlare1.Create(FOwner,X,Y));
    //FOwner.Add(TSpark2.Create(FOwner, 8, 768,160,X,Y));
    FOwner.Add(TDyingBoss1.Create(FOwner,X,Y));
    info.x:=x;
    info.y:=y;
    info.point:=SC_BOSS1;
    SendMessage(Parent,MSG_DESTROYED,@info);

    if LWAlive then begin
      LWeapon.OnDamaged(1000);
    end;

    if RWAlive then begin
      RWeapon.OnDamaged(1000);
    end;

    if CovAlive then begin
      Cover.OnDamaged(1000);
    end;

    Die;
  end;
end;

procedure TBoss1.OnCrush(target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(10);
end;


procedure TBoss1.CatchMessage(msg:Word; param:Pointer);
begin
  //킪󂳂ꂽAΑɈU
  if Param = LWeapon then begin
    Rewind:=False;
    LWAlive:=False;
    CurV.X:=CurV.X + 7;
  end;

  if Param = RWeapon then begin
    Rewind:=True;
    RWAlive:=False;
    CurV.X:=CurV.X - 7;
  end;

  if Param = Cover then
    CovAlive:=False;
end;



////////////////////////////
// {X1AC
////////////////////////////

//̖C
constructor TBoss1Weapon.CreateL(owner:TMoverList; p:TPoint);
begin
  inherited Create(owner);

  IamL:=True;
  HP:=150;

  //蔻̏
  FAttr:=maEnemy;
  nTouchRect:=4;
  FTouchRect[0]:=Rect(-3,-128,+36,-69);
  FTouchRect[1]:=Rect(-2,-69,+35,+3);
  FTouchRect[2]:=Rect(-17,-8,+10,+51);
  FTouchRect[3]:=Rect(-36,+52,-1,+101);

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=S_Boss1L;
    MinAnim:=0;
    MaxAnim:=0;
    iAnim:=0;
    Visible:=True;
    Z:=Z_SHOT;  //Dx
  end;

  FCharging:=False;
  FCooling:=False;
end;


constructor TBoss1Weapon.CreateR(owner:TMoverList; p:TPoint);
begin
  inherited Create(owner);

  IamL:=False;
  HP:=150;

  //蔻̏
  FAttr:=maEnemy;
  nTouchRect:=4;
  FTouchRect[0]:=Rect(-36,-128,+3,-69);
  FTouchRect[1]:=Rect(-35,-69,+2,+3);
  FTouchRect[2]:=Rect(-10,-8,+17,+51);
  FTouchRect[3]:=Rect(+1,+52,+36,+101);

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=S_BOSS1R;
    MinAnim:=0;
    MaxAnim:=0;
    iAnim:=0;
    Visible:=True;
    Z:=Z_SHOT;  //Dx
  end;

  FCharging:=False;
  FCooling:=False;
end;

destructor TBoss1Weapon.Destroy;
begin
  FOwner.FreeSprite(mySpr);
  inherited;
end;

procedure TBoss1Weapon.Move(t:Integer);
begin
  inherited;

  //es`A͂B
  if Parent.HP < 250 then
    OnDamaged(1000);

  if Charging And (ChargeT+60 < AgeT) then begin
    FCharging:=False;
    FCooling:=True;
  end;

  if FCooling And (ChargeT+180 < AgeT) then
    FCooling:=False;

  //`[WIA
  if not FCooling then
    Exit;

  if (PrevShootT+10 < AgeT) And (NShoot <= GAMELEVEL*4) then begin
    if IamL then
      FOwner.Add(THadou.Create(FOwner,Point(X-24,Y+148),Vector2D(0,16)))
    else
      FOwner.Add(THadou.Create(FOwner,Point(X+24,Y+148),Vector2D(0,16)));
    PrevShootT:=AgeT;
    Inc(NShoot);
  end;
  
end;

procedure TBoss1Weapon.MoveTo(xx,yy:Integer);
begin
  x:=xx;
  y:=yy;
  FOwner.Spr[mySpr].X:=xx-48;
  FOwner.Spr[mySpr].Y:=yy-144;
end;

procedure TBoss1Weapon.OnDie;
begin
  inherited;
  FOwner.Spr[mySpr].Hide;
end;

procedure TBoss1Weapon.OnDamaged(dmg:Integer);
//var
  //info:TDestroyInfo;
begin
  inherited;

  //HP炷
  Dec(HP,dmg);

  //HP0ȉɂȂA
  if HP <= 0 then begin
    FOwner.Score:=FOwner.Score + SC_Boss1Weapon;
    FOwner.Add(TDyingBoss1Weapon.Create(FOwner,X,Y,IamL));
    //FOwner.Add(TFlare1.Create(FOwner,X,Y));
    //FOwner.Add(TSpark2.Create(FOwner, 8, 768,160, X,Y));

    //info.x:=x;
    //info.y:=y;
    //info.point:=SC_Boss1Weapon;
    SendMessage(Parent,MSG_DESTROYED,Self);
    Die;
  end;
end;

procedure TBoss1Weapon.OnCrush(target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(10);
end;


//
procedure TBoss1Weapon.Charge;
begin

  //ŌɃ`[WԂ180t[̓`[Ws
  if FCharging Or FCooling then
    Exit;

  //`[WJn
  ChargeT := AgeT;
  FCharging := True;

  if IamL then
    FOwner.Add(TSpark3.Create(FOwner,X-24,Y+128))
  else
    FOwner.Add(TSpark3.Create(FOwner,X+24,Y+128));

  NShoot:=0;
  PrevShootT:=0;
end;



////////////////////////////
// {X1AJo[
////////////////////////////

constructor TBoss1Cover.Create(owner:TMoverList; p:TPoint);
begin
  inherited Create(owner);

  HP:=150;

  //蔻̏
  FAttr:=maEnemy;
  nTouchRect:=2;
  FTouchRect[0]:=Rect(-46,-43,+6,+4);
  FTouchRect[1]:=Rect(-35,-5,+35,38);

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=S_BOSS1C;
    MinAnim:=0;
    MaxAnim:=0;
    iAnim:=0;
    Visible:=True;
    Z:=Z_HIGH;  //Dx
  end;

end;

destructor TBoss1Cover.Destroy;
begin
  FOwner.FreeSprite(mySpr);
  inherited;
end;

procedure TBoss1Cover.Move(t:Integer);
begin
  inherited;

  //es`AJo[͂B
  if Parent.HP < 350 then
    OnDamaged(1000);
end;

procedure TBoss1Cover.MoveTo(xx,yy:Integer);
begin
  x:=xx;
  y:=yy;
  FOwner.Spr[mySpr].X:=xx-56;
  FOwner.Spr[mySpr].Y:=yy-56;
end;

procedure TBoss1Cover.OnDie;
begin
  inherited;
  FOwner.Spr[mySpr].Hide;
end;

procedure TBoss1Cover.OnDamaged(dmg:Integer);
//var
  //info:TDestroyInfo;
begin
  inherited;

  //HP炷
  Dec(HP,dmg);

  //HP0ȉɂȂA
  if HP <= 0 then begin
    FOwner.Score:=FOwner.Score + SC_Boss1Cover;

    FOwner.Add(TDyingBoss1Cover.Create(FOwner,X,Y));

    //info.x:=x;
    //info.y:=y;
    //info.point:=SC_Boss1Cover;
    SendMessage(Parent,MSG_DESTROYED,Self);
    Die;
  end;
end;

procedure TBoss1Cover.OnCrush(target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(10);
end;




////////////////////////////
// gC
////////////////////////////
constructor THadou.Create(owner:TMoverList;p:TPoint; v:TVector2D);
begin
  inherited Create(owner);

  pos:=Vector2D(p.x,p.y);
  v0:=v;

  //蔻̏
  FAttr:=maEB;
  nTouchRect:=1;
  FTouchRect[0]:=Rect(-12,0,+12,+48);


  MoveTo(Round(pos.x),Round(pos.y));

end;

destructor THadou.Destroy;
begin
  inherited;
end;

procedure THadou.Move(t:Integer);
begin
  inherited;

  pos.X:=pos.x + v0.X*t;
  pos.Y:=pos.Y + v0.Y*t;

  MoveTo(Round(pos.X),Round(pos.Y));

  if (Y > 540) Or (Y < -40) Or (X > 700) Or (X<-60) then begin
    Die;
  end;

  //`
  FOwner.Rend.PushPatternRect(P_HADOU + (AgeT mod 6), SingleRect(X-64,Y-80,X+64,Y+80),Z_ESHOT,bmAdd,$FFFFFFFF);

  {
  //_悤
  FOwner.Score:=FOwner.Score + SC_EB1 * t;
  }
end;

procedure THadou.MoveTo(xx,yy:Integer);
begin
  x:=xx;
  y:=yy;
end;

procedure THadou.OnDie;
begin
  inherited;
end;

procedure THadou.OnCrush(target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(1);
end;


//V[J[Cɕ߂܂
procedure THadou.OnDamaged(dmg:Integer);
begin
  v0.Y:=v0.Y - 2;
  if v0.Y < 2 then
    v0.Y:=2;
end;

end.
